]> Pileus Git - ~andy/git/blob - git-am.sh
am -3: list the paths that needed 3-way fallback
[~andy/git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 keep-non-patch  pass -b flag to git-mailinfo
19 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors      strip everything before a scissors line
22 whitespace=     pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory=      pass it through git-apply
26 exclude=        pass it through git-apply
27 C=              pass it through git-apply
28 p=              pass it through git-apply
29 patch-format=   format the patch(es) are in
30 reject          pass it through git-apply
31 resolvemsg=     override error message when patch failure occurs
32 continue        continue applying patches after resolving a conflict
33 r,resolved      synonyms for --continue
34 skip            skip the current patch
35 abort           restore the original branch and abort the patching operation.
36 committer-date-is-author-date    lie about committer date
37 ignore-date     use current timestamp for author date
38 rerere-autoupdate update the index with reused conflict resolution if possible
39 rebasing*       (internal use for git-rebase)"
40
41 . git-sh-setup
42 . git-sh-i18n
43 prefix=$(git rev-parse --show-prefix)
44 set_reflog_action am
45 require_work_tree
46 cd_to_toplevel
47
48 git var GIT_COMMITTER_IDENT >/dev/null ||
49         die "$(gettext "You need to set your committer info first")"
50
51 if git rev-parse --verify -q HEAD >/dev/null
52 then
53         HAS_HEAD=yes
54 else
55         HAS_HEAD=
56 fi
57
58 cmdline="git am"
59 if test '' != "$interactive"
60 then
61         cmdline="$cmdline -i"
62 fi
63 if test '' != "$threeway"
64 then
65         cmdline="$cmdline -3"
66 fi
67
68 sq () {
69         git rev-parse --sq-quote "$@"
70 }
71
72 stop_here () {
73     echo "$1" >"$dotest/next"
74     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
75     exit 1
76 }
77
78 safe_to_abort () {
79         if test -f "$dotest/dirtyindex"
80         then
81                 return 1
82         fi
83
84         if ! test -s "$dotest/abort-safety"
85         then
86                 return 0
87         fi
88
89         abort_safety=$(cat "$dotest/abort-safety")
90         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
91         then
92                 return 0
93         fi
94                 gettextln "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" >&2
96         return 1
97 }
98
99 stop_here_user_resolve () {
100     if [ -n "$resolvemsg" ]; then
101             printf '%s\n' "$resolvemsg"
102             stop_here $1
103     fi
104     eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
105 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
106 To restore the original branch and stop patching run \"\$cmdline --abort\"."
107
108     stop_here $1
109 }
110
111 go_next () {
112         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
113                 "$dotest/patch" "$dotest/info"
114         echo "$next" >"$dotest/next"
115         this=$next
116 }
117
118 cannot_fallback () {
119         echo "$1"
120         gettextln "Cannot fall back to three-way merge."
121         exit 1
122 }
123
124 fall_back_3way () {
125     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
126
127     rm -fr "$dotest"/patch-merge-*
128     mkdir "$dotest/patch-merge-tmp-dir"
129
130     # First see if the patch records the index info that we can use.
131     cmd="git apply $git_apply_opt --build-fake-ancestor" &&
132     cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
133     eval "$cmd" &&
134     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
135     git write-tree >"$dotest/patch-merge-base+" ||
136     cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
137
138     say Using index info to reconstruct a base tree...
139
140     cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
141
142     if test -z "$GIT_QUIET"
143     then
144         eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
145     fi
146
147     cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
148     if eval "$cmd"
149     then
150         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
151         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
152     else
153         cannot_fallback "$(gettext "Did you hand edit your patch?
154 It does not apply to blobs recorded in its index.")"
155     fi
156
157     test -f "$dotest/patch-merge-index" &&
158     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
159     orig_tree=$(cat "$dotest/patch-merge-base") &&
160     rm -fr "$dotest"/patch-merge-* || exit 1
161
162     say "$(gettext "Falling back to patching base and 3-way merge...")"
163
164     # This is not so wrong.  Depending on which base we picked,
165     # orig_tree may be wildly different from ours, but his_tree
166     # has the same set of wildly different changes in parts the
167     # patch did not touch, so recursive ends up canceling them,
168     # saying that we reverted all those changes.
169
170     eval GITHEAD_$his_tree='"$FIRSTLINE"'
171     export GITHEAD_$his_tree
172     if test -n "$GIT_QUIET"
173     then
174             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
175     fi
176     git-merge-recursive $orig_tree -- HEAD $his_tree || {
177             git rerere $allow_rerere_autoupdate
178             echo Failed to merge in the changes.
179             exit 1
180     }
181     unset GITHEAD_$his_tree
182 }
183
184 clean_abort () {
185         test $# = 0 || echo >&2 "$@"
186         rm -fr "$dotest"
187         exit 1
188 }
189
190 patch_format=
191
192 check_patch_format () {
193         # early return if patch_format was set from the command line
194         if test -n "$patch_format"
195         then
196                 return 0
197         fi
198
199         # we default to mbox format if input is from stdin and for
200         # directories
201         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
202         then
203                 patch_format=mbox
204                 return 0
205         fi
206
207         # otherwise, check the first few non-blank lines of the first
208         # patch to try to detect its format
209         {
210                 # Start from first line containing non-whitespace
211                 l1=
212                 while test -z "$l1"
213                 do
214                         read l1 || break
215                 done
216                 read l2
217                 read l3
218                 case "$l1" in
219                 "From "* | "From: "*)
220                         patch_format=mbox
221                         ;;
222                 '# This series applies on GIT commit'*)
223                         patch_format=stgit-series
224                         ;;
225                 "# HG changeset patch")
226                         patch_format=hg
227                         ;;
228                 *)
229                         # if the second line is empty and the third is
230                         # a From, Author or Date entry, this is very
231                         # likely an StGIT patch
232                         case "$l2,$l3" in
233                         ,"From: "* | ,"Author: "* | ,"Date: "*)
234                                 patch_format=stgit
235                                 ;;
236                         *)
237                                 ;;
238                         esac
239                         ;;
240                 esac
241                 if test -z "$patch_format" &&
242                         test -n "$l1" &&
243                         test -n "$l2" &&
244                         test -n "$l3"
245                 then
246                         # This begins with three non-empty lines.  Is this a
247                         # piece of e-mail a-la RFC2822?  Grab all the headers,
248                         # discarding the indented remainder of folded lines,
249                         # and see if it looks like that they all begin with the
250                         # header field names...
251                         tr -d '\015' <"$1" |
252                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
253                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
254                         patch_format=mbox
255                 fi
256         } < "$1" || clean_abort
257 }
258
259 split_patches () {
260         case "$patch_format" in
261         mbox)
262                 if test -n "$rebasing" || test t = "$keepcr"
263                 then
264                     keep_cr=--keep-cr
265                 else
266                     keep_cr=
267                 fi
268                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
269                 clean_abort
270                 ;;
271         stgit-series)
272                 if test $# -ne 1
273                 then
274                         clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
275                 fi
276                 series_dir=`dirname "$1"`
277                 series_file="$1"
278                 shift
279                 {
280                         set x
281                         while read filename
282                         do
283                                 set "$@" "$series_dir/$filename"
284                         done
285                         # remove the safety x
286                         shift
287                         # remove the arg coming from the first-line comment
288                         shift
289                 } < "$series_file" || clean_abort
290                 # set the patch format appropriately
291                 patch_format=stgit
292                 # now handle the actual StGIT patches
293                 split_patches "$@"
294                 ;;
295         stgit)
296                 this=0
297                 for stgit in "$@"
298                 do
299                         this=`expr "$this" + 1`
300                         msgnum=`printf "%0${prec}d" $this`
301                         # Perl version of StGIT parse_patch. The first nonemptyline
302                         # not starting with Author, From or Date is the
303                         # subject, and the body starts with the next nonempty
304                         # line not starting with Author, From or Date
305                         perl -ne 'BEGIN { $subject = 0 }
306                                 if ($subject > 1) { print ; }
307                                 elsif (/^\s+$/) { next ; }
308                                 elsif (/^Author:/) { s/Author/From/ ; print ;}
309                                 elsif (/^(From|Date)/) { print ; }
310                                 elsif ($subject) {
311                                         $subject = 2 ;
312                                         print "\n" ;
313                                         print ;
314                                 } else {
315                                         print "Subject: ", $_ ;
316                                         $subject = 1;
317                                 }
318                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
319                 done
320                 echo "$this" > "$dotest/last"
321                 this=
322                 msgnum=
323                 ;;
324         hg)
325                 this=0
326                 for hg in "$@"
327                 do
328                         this=$(( $this + 1 ))
329                         msgnum=$(printf "%0${prec}d" $this)
330                         # hg stores changeset metadata in #-commented lines preceding
331                         # the commit message and diff(s). The only metadata we care about
332                         # are the User and Date (Node ID and Parent are hashes which are
333                         # only relevant to the hg repository and thus not useful to us)
334                         # Since we cannot guarantee that the commit message is in
335                         # git-friendly format, we put no Subject: line and just consume
336                         # all of the message as the body
337                         perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
338                                 if ($subject) { print ; }
339                                 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
340                                 elsif (/^\# Date /) {
341                                         my ($hashsign, $str, $time, $tz) = split ;
342                                         $tz = sprintf "%+05d", (0-$tz)/36;
343                                         print "Date: " .
344                                               strftime("%a, %d %b %Y %H:%M:%S ",
345                                                        localtime($time))
346                                               . "$tz\n";
347                                 } elsif (/^\# /) { next ; }
348                                 else {
349                                         print "\n", $_ ;
350                                         $subject = 1;
351                                 }
352                         ' <"$hg" >"$dotest/$msgnum" || clean_abort
353                 done
354                 echo "$this" >"$dotest/last"
355                 this=
356                 msgnum=
357                 ;;
358         *)
359                 if test -n "$patch_format"
360                 then
361                         clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
362                 else
363                         clean_abort "$(gettext "Patch format detection failed.")"
364                 fi
365                 ;;
366         esac
367 }
368
369 prec=4
370 dotest="$GIT_DIR/rebase-apply"
371 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
372 resolvemsg= resume= scissors= no_inbody_headers=
373 git_apply_opt=
374 committer_date_is_author_date=
375 ignore_date=
376 allow_rerere_autoupdate=
377
378 if test "$(git config --bool --get am.keepcr)" = true
379 then
380     keepcr=t
381 fi
382
383 while test $# != 0
384 do
385         case "$1" in
386         -i|--interactive)
387                 interactive=t ;;
388         -b|--binary)
389                 echo >&2 "The $1 option has been a no-op for long time, and"
390                 echo >&2 "it will be removed. Please do not use it anymore."
391                 ;;
392         -3|--3way)
393                 threeway=t ;;
394         -s|--signoff)
395                 sign=t ;;
396         -u|--utf8)
397                 utf8=t ;; # this is now default
398         --no-utf8)
399                 utf8= ;;
400         -k|--keep)
401                 keep=t ;;
402         --keep-non-patch)
403                 keep=b ;;
404         -c|--scissors)
405                 scissors=t ;;
406         --no-scissors)
407                 scissors=f ;;
408         -r|--resolved|--continue)
409                 resolved=t ;;
410         --skip)
411                 skip=t ;;
412         --abort)
413                 abort=t ;;
414         --rebasing)
415                 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
416         -d|--dotest)
417                 die "$(gettext "-d option is no longer supported.  Do not use.")"
418                 ;;
419         --resolvemsg)
420                 shift; resolvemsg=$1 ;;
421         --whitespace|--directory|--exclude)
422                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
423         -C|-p)
424                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
425         --patch-format)
426                 shift ; patch_format="$1" ;;
427         --reject|--ignore-whitespace|--ignore-space-change)
428                 git_apply_opt="$git_apply_opt $1" ;;
429         --committer-date-is-author-date)
430                 committer_date_is_author_date=t ;;
431         --ignore-date)
432                 ignore_date=t ;;
433         --rerere-autoupdate|--no-rerere-autoupdate)
434                 allow_rerere_autoupdate="$1" ;;
435         -q|--quiet)
436                 GIT_QUIET=t ;;
437         --keep-cr)
438                 keepcr=t ;;
439         --no-keep-cr)
440                 keepcr=f ;;
441         --)
442                 shift; break ;;
443         *)
444                 usage ;;
445         esac
446         shift
447 done
448
449 # If the dotest directory exists, but we have finished applying all the
450 # patches in them, clear it out.
451 if test -d "$dotest" &&
452    last=$(cat "$dotest/last") &&
453    next=$(cat "$dotest/next") &&
454    test $# != 0 &&
455    test "$next" -gt "$last"
456 then
457    rm -fr "$dotest"
458 fi
459
460 if test -d "$dotest"
461 then
462         case "$#,$skip$resolved$abort" in
463         0,*t*)
464                 # Explicit resume command and we do not have file, so
465                 # we are happy.
466                 : ;;
467         0,)
468                 # No file input but without resume parameters; catch
469                 # user error to feed us a patch from standard input
470                 # when there is already $dotest.  This is somewhat
471                 # unreliable -- stdin could be /dev/null for example
472                 # and the caller did not intend to feed us a patch but
473                 # wanted to continue unattended.
474                 test -t 0
475                 ;;
476         *)
477                 false
478                 ;;
479         esac ||
480         die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
481         resume=yes
482
483         case "$skip,$abort" in
484         t,t)
485                 die "$(gettext "Please make up your mind. --skip or --abort?")"
486                 ;;
487         t,)
488                 git rerere clear
489                 git read-tree --reset -u HEAD HEAD
490                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
491                 git reset HEAD
492                 git update-ref ORIG_HEAD $orig_head
493                 ;;
494         ,t)
495                 if test -f "$dotest/rebasing"
496                 then
497                         exec git rebase --abort
498                 fi
499                 git rerere clear
500                 if safe_to_abort
501                 then
502                         git read-tree --reset -u HEAD ORIG_HEAD
503                         git reset ORIG_HEAD
504                 fi
505                 rm -fr "$dotest"
506                 exit ;;
507         esac
508         rm -f "$dotest/dirtyindex"
509 else
510         # Make sure we are not given --skip, --resolved, nor --abort
511         test "$skip$resolved$abort" = "" ||
512                 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
513
514         # Start afresh.
515         mkdir -p "$dotest" || exit
516
517         if test -n "$prefix" && test $# != 0
518         then
519                 first=t
520                 for arg
521                 do
522                         test -n "$first" && {
523                                 set x
524                                 first=
525                         }
526                         if is_absolute_path "$arg"
527                         then
528                                 set "$@" "$arg"
529                         else
530                                 set "$@" "$prefix$arg"
531                         fi
532                 done
533                 shift
534         fi
535
536         check_patch_format "$@"
537
538         split_patches "$@"
539
540         # -i can and must be given when resuming; everything
541         # else is kept
542         echo " $git_apply_opt" >"$dotest/apply-opt"
543         echo "$threeway" >"$dotest/threeway"
544         echo "$sign" >"$dotest/sign"
545         echo "$utf8" >"$dotest/utf8"
546         echo "$keep" >"$dotest/keep"
547         echo "$scissors" >"$dotest/scissors"
548         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
549         echo "$GIT_QUIET" >"$dotest/quiet"
550         echo 1 >"$dotest/next"
551         if test -n "$rebasing"
552         then
553                 : >"$dotest/rebasing"
554         else
555                 : >"$dotest/applying"
556                 if test -n "$HAS_HEAD"
557                 then
558                         git update-ref ORIG_HEAD HEAD
559                 else
560                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
561                 fi
562         fi
563 fi
564
565 git update-index -q --refresh
566
567 case "$resolved" in
568 '')
569         case "$HAS_HEAD" in
570         '')
571                 files=$(git ls-files) ;;
572         ?*)
573                 files=$(git diff-index --cached --name-only HEAD --) ;;
574         esac || exit
575         if test "$files"
576         then
577                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
578                 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
579         fi
580 esac
581
582 # Now, decide what command line options we will give to the git
583 # commands we invoke, based on the result of parsing command line
584 # options and previous invocation state stored in $dotest/ files.
585
586 if test "$(cat "$dotest/utf8")" = t
587 then
588         utf8=-u
589 else
590         utf8=-n
591 fi
592 keep=$(cat "$dotest/keep")
593 case "$keep" in
594 t)
595         keep=-k ;;
596 b)
597         keep=-b ;;
598 *)
599         keep= ;;
600 esac
601 case "$(cat "$dotest/scissors")" in
602 t)
603         scissors=--scissors ;;
604 f)
605         scissors=--no-scissors ;;
606 esac
607 if test "$(cat "$dotest/no_inbody_headers")" = t
608 then
609         no_inbody_headers=--no-inbody-headers
610 else
611         no_inbody_headers=
612 fi
613 if test "$(cat "$dotest/quiet")" = t
614 then
615         GIT_QUIET=t
616 fi
617 if test "$(cat "$dotest/threeway")" = t
618 then
619         threeway=t
620 fi
621 git_apply_opt=$(cat "$dotest/apply-opt")
622 if test "$(cat "$dotest/sign")" = t
623 then
624         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
625                         s/>.*/>/
626                         s/^/Signed-off-by: /'
627                 `
628 else
629         SIGNOFF=
630 fi
631
632 last=`cat "$dotest/last"`
633 this=`cat "$dotest/next"`
634 if test "$skip" = t
635 then
636         this=`expr "$this" + 1`
637         resume=
638 fi
639
640 while test "$this" -le "$last"
641 do
642         msgnum=`printf "%0${prec}d" $this`
643         next=`expr "$this" + 1`
644         test -f "$dotest/$msgnum" || {
645                 resume=
646                 go_next
647                 continue
648         }
649
650         # If we are not resuming, parse and extract the patch information
651         # into separate files:
652         #  - info records the authorship and title
653         #  - msg is the rest of commit log message
654         #  - patch is the patch body.
655         #
656         # When we are resuming, these files are either already prepared
657         # by the user, or the user can tell us to do so by --resolved flag.
658         case "$resume" in
659         '')
660                 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
661                         <"$dotest/$msgnum" >"$dotest/info" ||
662                         stop_here $this
663
664                 # skip pine's internal folder data
665                 sane_grep '^Author: Mail System Internal Data$' \
666                         <"$dotest"/info >/dev/null &&
667                         go_next && continue
668
669                 test -s "$dotest/patch" || {
670                         eval_gettextln "Patch is empty.  Was it split wrong?
671 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
672 To restore the original branch and stop patching run \"\$cmdline --abort\"."
673                         stop_here $this
674                 }
675                 rm -f "$dotest/original-commit" "$dotest/author-script"
676                 if test -f "$dotest/rebasing" &&
677                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
678                                 -e q "$dotest/$msgnum") &&
679                         test "$(git cat-file -t "$commit")" = commit
680                 then
681                         git cat-file commit "$commit" |
682                         sed -e '1,/^$/d' >"$dotest/msg-clean"
683                         echo "$commit" > "$dotest/original-commit"
684                         get_author_ident_from_commit "$commit" > "$dotest/author-script"
685                 else
686                         {
687                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
688                                 echo
689                                 cat "$dotest/msg"
690                         } |
691                         git stripspace > "$dotest/msg-clean"
692                 fi
693                 ;;
694         esac
695
696         if test -f "$dotest/author-script"
697         then
698                 eval $(cat "$dotest/author-script")
699         else
700                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
701                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
702                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
703         fi
704
705         if test -z "$GIT_AUTHOR_EMAIL"
706         then
707                 gettextln "Patch does not have a valid e-mail address."
708                 stop_here $this
709         fi
710
711         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
712
713         case "$resume" in
714         '')
715             if test '' != "$SIGNOFF"
716             then
717                 LAST_SIGNED_OFF_BY=`
718                     sed -ne '/^Signed-off-by: /p' \
719                     "$dotest/msg-clean" |
720                     sed -ne '$p'
721                 `
722                 ADD_SIGNOFF=`
723                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
724                     test '' = "$LAST_SIGNED_OFF_BY" && echo
725                     echo "$SIGNOFF"
726                 }`
727             else
728                 ADD_SIGNOFF=
729             fi
730             {
731                 if test -s "$dotest/msg-clean"
732                 then
733                         cat "$dotest/msg-clean"
734                 fi
735                 if test '' != "$ADD_SIGNOFF"
736                 then
737                         echo "$ADD_SIGNOFF"
738                 fi
739             } >"$dotest/final-commit"
740             ;;
741         *)
742                 case "$resolved$interactive" in
743                 tt)
744                         # This is used only for interactive view option.
745                         git diff-index -p --cached HEAD -- >"$dotest/patch"
746                         ;;
747                 esac
748         esac
749
750         resume=
751         if test "$interactive" = t
752         then
753             test -t 0 ||
754             die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
755             action=again
756             while test "$action" = again
757             do
758                 gettextln "Commit Body is:"
759                 echo "--------------------------"
760                 cat "$dotest/final-commit"
761                 echo "--------------------------"
762                 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
763                 # in your translation. The program will only accept English
764                 # input at this point.
765                 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
766                 read reply
767                 case "$reply" in
768                 [yY]*) action=yes ;;
769                 [aA]*) action=yes interactive= ;;
770                 [nN]*) action=skip ;;
771                 [eE]*) git_editor "$dotest/final-commit"
772                        action=again ;;
773                 [vV]*) action=again
774                        git_pager "$dotest/patch" ;;
775                 *)     action=again ;;
776                 esac
777             done
778         else
779             action=yes
780         fi
781
782         if test -f "$dotest/final-commit"
783         then
784                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
785         else
786                 FIRSTLINE=""
787         fi
788
789         if test $action = skip
790         then
791                 go_next
792                 continue
793         fi
794
795         if test -x "$GIT_DIR"/hooks/applypatch-msg
796         then
797                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
798                 stop_here $this
799         fi
800
801         say "$(eval_gettext "Applying: \$FIRSTLINE")"
802
803         case "$resolved" in
804         '')
805                 # When we are allowed to fall back to 3-way later, don't give
806                 # false errors during the initial attempt.
807                 squelch=
808                 if test "$threeway" = t
809                 then
810                         squelch='>/dev/null 2>&1 '
811                 fi
812                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
813                 apply_status=$?
814                 ;;
815         t)
816                 # Resolved means the user did all the hard work, and
817                 # we do not have to do any patch application.  Just
818                 # trust what the user has in the index file and the
819                 # working tree.
820                 resolved=
821                 git diff-index --quiet --cached HEAD -- && {
822                         gettextln "No changes - did you forget to use 'git add'?
823 If there is nothing left to stage, chances are that something else
824 already introduced the same changes; you might want to skip this patch."
825                         stop_here_user_resolve $this
826                 }
827                 unmerged=$(git ls-files -u)
828                 if test -n "$unmerged"
829                 then
830                         gettextln "You still have unmerged paths in your index
831 did you forget to use 'git add'?"
832                         stop_here_user_resolve $this
833                 fi
834                 apply_status=0
835                 git rerere
836                 ;;
837         esac
838
839         if test $apply_status != 0 && test "$threeway" = t
840         then
841                 if (fall_back_3way)
842                 then
843                     # Applying the patch to an earlier tree and merging the
844                     # result may have produced the same tree as ours.
845                     git diff-index --quiet --cached HEAD -- && {
846                         say "$(gettext "No changes -- Patch already applied.")"
847                         go_next
848                         continue
849                     }
850                     # clear apply_status -- we have successfully merged.
851                     apply_status=0
852                 fi
853         fi
854         if test $apply_status != 0
855         then
856                 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
857                 stop_here_user_resolve $this
858         fi
859
860         if test -x "$GIT_DIR"/hooks/pre-applypatch
861         then
862                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
863         fi
864
865         tree=$(git write-tree) &&
866         commit=$(
867                 if test -n "$ignore_date"
868                 then
869                         GIT_AUTHOR_DATE=
870                 fi
871                 parent=$(git rev-parse --verify -q HEAD) ||
872                 say >&2 "$(gettext "applying to an empty history")"
873
874                 if test -n "$committer_date_is_author_date"
875                 then
876                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
877                         export GIT_COMMITTER_DATE
878                 fi &&
879                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
880         ) &&
881         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
882         stop_here $this
883
884         if test -f "$dotest/original-commit"; then
885                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
886         fi
887
888         if test -x "$GIT_DIR"/hooks/post-applypatch
889         then
890                 "$GIT_DIR"/hooks/post-applypatch
891         fi
892
893         go_next
894 done
895
896 if test -s "$dotest"/rewritten; then
897     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
898     if test -x "$GIT_DIR"/hooks/post-rewrite; then
899         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
900     fi
901 fi
902
903 rm -fr "$dotest"
904 git gc --auto